/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <1gaack@informatik.uni-hamburg.de> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return Moritz Gaack
 * ----------------------------------------------------------------------------
 */

#ifndef __MY_OBJECT_H__
#define __MY_OBJECT_H__

#include <glib-object.h>

G_BEGIN_DECLS


#define MY_TYPE_OBJECT                   (my_object_get_type ())
#define MY_OBJECT(obj)                   (G_TYPE_CHECK_INSTANCE_CAST ((obj), MY_TYPE_OBJECT, MyObject))
#define MY_IS_OBJECT(obj)                (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MY_TYPE_OBJECT))
#define MY_OBJECT_CLASS(_class)          (G_TYPE_CHECK_CLASS_CAST ((_class), MY_TYPE_OBJECT, MyObjectClass))
#define MY_IS_OBJECT_CLASS(_class)       (G_TYPE_CHECK_CLASS_TYPE ((_class), MY_TYPE_OBJECT))
#define MY_OBJECT_GET_CLASS(obj)         (G_TYPE_INSTANCE_GET_CLASS ((obj), MY_TYPE_OBJECT, MyObjectClass))


typedef struct _MyObject MyObject;
typedef struct _MyObjectClass MyObjectClass;


struct _MyObject
{
    GObject parent_instance;
};

struct _MyObjectClass
{
    GObjectClass parent_class;
};


/**
 * Funktion liefert den Typen der Klasse MyObject.
 *
 * @return Zeiger auf die erzeugte Instanz der Klasse MyObject.
 * @see my_object_new(int)
 */
GType my_object_get_type(void) G_GNUC_CONST;


/**
 * Funktion entspricht dem Konstruktor der Klasse MyObject.
 *
 * @param value Wert der int-Vairablen, die im Konstruktor initialisert wird.
 * @return Zeiger auf die erzeugte Instanz der Klasse MyObject.
 * @see my_object_get_type()
 * @see my_object_set_value(void *, int)
 * @see my_object_get_value(void *)
 */
MyObject * my_object_new(int value);


/**
 * Funktion liefert den Wert einer gekapselten int-Variablen der Klasse MyObject.
 *
 * @param myObject Zeiger auf das myObject-Objekt, welches die int-Variable kapselt
 * @return Wert der int-Variable
 * @see my_object_new(size_t)
 * @see my_object_set_value(void *, int)
 */
int my_object_get_value(MyObject * myObject);


/**
 * Funktion setzt den Wert der gekapselten int-Variablen in der Klasse MyObject.
 *
 * @param myObject Zeiger auf das myObject-Objekt, welches die int-Variable kapselt
 * @param Wert der int-Variable, der gesetzt werden soll
 * @see my_object_new(size_t)
 * @see my_object_get_value(void *)
 */
void my_object_set_value(MyObject *myObject, int value);

G_END_DECLS

#endif
