
/* Copyright (c) 2013, Jean-David Gadina - www.xs-labs.com
 * All rights reserved.
 *
 * Redistribution and use in source (SGML DocBook) and 'compiled' forms (SGML,
 * HTML, PDF, PostScript, RTF and so forth) with or without modification, are
 * permitted provided that the following conditions are met:
 *
 *  + Redistributions of source code (SGML DocBook) must retain the above
 *    copyright notice, this list of conditions and the following disclaimer
 *    as the first lines of this file unmodified.
 *
 *  + Redistributions in compiled form (transformed to other DTDs, converted
 *    to PDF, PostScript, RTF and other formats) must reproduce the above
 *    copyright notice, this list of conditions and the following disclaimer
 *    in the documentation and/or other materials provided with the
 *    distribution.
 *
 * THIS DOCUMENTATION IS PROVIDED BY THE XS-LABS DOCUMENTATION PROJECT "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL XS-LABS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS DOCUMENTATION, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 */


#include "ReferenceCountingImplJDG.h"

void * alloc(size_t size)
{
    MemoryObject * o = NULL;
    char * ptr = NULL;
    
    o = (MemoryObject *)calloc(1, sizeof(MemoryObject) + size);
    if(o != NULL)
    {
        ptr = (char *)o;
        ptr += sizeof(MemoryObject);
        o->data = ptr;
        o->retainCount = 1;
    }
    
    return (void *)ptr;
}


void retain(void * ptr)
{
    MemoryObject * o = NULL;
    char * cptr = NULL;
    
    cptr = (char *)ptr;
    cptr -= sizeof(MemoryObject);
    o = (MemoryObject *)cptr;
    
    o->retainCount++;
}


void release(void * ptr)
{
    MemoryObject * o = NULL;
    char * cptr = NULL;
    
    cptr = (char *)ptr;
    cptr -= sizeof(MemoryObject);
    o = (MemoryObject *)cptr;
    
    if(--o->retainCount == 0)
    {
        free(o);
        o = NULL;
    }
}
